{***************************************************************************}
{                           UNIDAD DE MOUSE DRIVER

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

unit umd;

interface

  type
    pcursor = ^rcursor;

    rcursor = record
      x,
      y : integer;
      mascara,
      imagen : array [0..15] of word;
    end;

  var
{Error:
  1 = el manejador de ratn no est instalado.}
    error : word;

    estado,
    botones : word;

  procedure ajusta (var estado, botones : word);
  procedure muestra;
  procedure esconde;
  procedure tomaposicionboton (var boton, x, y : word);
  procedure mueve (x, y : word);
  procedure tomapresionboton (boton : word; var estado, presion, x, y :
    word);
  procedure tomaliberacionboton (boton : word; var estado, liberacion, x, y :
    word);
  procedure ponerangox (menor, mayor : word);
  procedure ponerangoy (menor, mayor : word);
  procedure ponecursorgrafico (cursor : pcursor);
  procedure ponecursortextoaplicacion (mascara, imagen : word);
  procedure ponecursortextoequipo (inicio, fin : word);
  procedure tomamovimiento (var x, y : word);
  procedure ponerutina (llamada : word; rutina : pointer);
  procedure ponelapizoptico;
  procedure quitalapizoptico;
  procedure ponemovimiento (x, y : word);
  procedure poneactualizacion (x1, y1, x2, y2 : word);
  procedure ponedoblevelocidad (velocidad : word);
  procedure cambiarutinas (llamada : word; rutina : pointer; var viejallamada
    : word; viejarutina : pointer);
  function tomatamanoestado : word;
  procedure salvaestado (hacia : pointer);
  procedure poneestado (desde : pointer);
  procedure poneinterrupcionalterna (llamada : word; campo : word);
  function tomainterrupcionalterna (llamada : word) : pointer;
  procedure ponesensibilidad (x, y, velocidad : word);
  procedure tomasensibilidad (var x, y, velocidad : word);
  procedure ponetiempointerrupcion (tiempo : word);
  procedure ponepagina (pagina : word);
  function tomapagina : word;
  procedure desactiva (var estado : word; var viejainterrupcion : pointer);
  procedure activa;
  procedure ajustaaplicacion;
  procedure poneidioma (idioma : word);
  function tomaidioma : word;
  procedure tomaversiontipo (var mayor, menor, tipo, interrupcion : byte);

implementation

  const
    interrupcionraton = $33;

    funcionajusta = $0000;
    funcionmuestra = $0001;
    funcionesconde = $0002;
    funciontomaposicionboton = $0003;
    funcionmueve = $0004;
    funciontomapresionboton = $0005;
    funciontomaliberacionboton = $0006;
    funcionponerangox = $0007;
    funcionponerangoy = $0008;
    funcionponecursorgrafico = $0009;
    funcionponecursortexto = $000a;
    funciontomamovimiento = $000b;
    funcionponerutina = $000c;
    funcionponelapizoptico = $000d;
    funcionquitalapizoptico = $000e;
    funcionponemovimiento = $000f;
    funcionponeactualizacion = $0010;
    funcionponedoblevelocidad = $0013;
    funcioncambiarutinas = $0014;
    funciontomatamanoestado = $0015;
    funcionsalvaestado = $0016;
    funcionponeestado = $0017;
    funcionponeinterrupcionalterna = $0018;
    funciontomainterrupcionalterna = $0019;
    funcionponesensibilidad = $001a;
    funciontomasensibilidad = $001b;
    funcionponetiempointerrupcion = $001c;
    funcionponepagina = $001d;
    funciontomapagina = $001e;
    funciondesactiva = $001f;
    funcionactiva = $0020;
    funcionajustaaplicacion = $0021;
    funcionponeidioma = $0022;
    funciontomaidioma = $0023;
    funciontomaversiontipo = $0024;

  procedure ajusta (var estado, botones : word); assembler;
  asm
    mov ax, funcionajusta;
    int interrupcionraton
    les di, estado
    mov es:word ptr [di], ax
    les di, botones
    mov es:word ptr [di], bx
  end;

  procedure muestra; assembler;
  asm
    mov ax, funcionmuestra
    int interrupcionraton
  end;

  procedure esconde; assembler;
  asm
    mov ax, funcionesconde
    int interrupcionraton
  end;

  procedure tomaposicionboton (var boton, x, y : word); assembler;
  asm
    mov ax, funciontomaposicionboton
    int interrupcionraton
    les di, boton
    mov es:word ptr [di], bx
    les di, x
    mov es:word ptr [di], cx
    les di, y
    mov es:word ptr [di], dx
  end;

  procedure mueve (x, y : word); assembler;
  asm
    mov ax, funcionmueve
    mov cx, x
    mov dx, y
    int interrupcionraton
  end;

  procedure tomapresionboton (boton : word; var estado, presion, x, y :
    word); assembler;
  asm
    mov ax, funciontomapresionboton
    mov bx, boton
    int interrupcionraton
    les di, estado
    mov es:word ptr [di], ax
    les di, presion
    mov es:word ptr [di], bx
    les di, x
    mov es:word ptr [di], cx
    les di, y
    mov es:word ptr [di], dx
  end;

  procedure tomaliberacionboton (boton : word; var estado, liberacion, x, y :
    word); assembler;
  asm
    mov ax, funciontomaliberacionboton
    int interrupcionraton
    les di, estado
    mov es:word ptr [di], ax
    les di, liberacion
    mov es:word ptr [di], bx
    les di, x
    mov es:word ptr [di], cx
    les di, y
    mov es:word ptr [di], dx
  end;

  procedure ponerangox (menor, mayor : word); assembler;
  asm
    mov ax, funcionponerangox
    mov cx, menor
    mov dx, mayor
    int interrupcionraton
  end;

  procedure ponerangoy (menor, mayor : word); assembler;
  asm
    mov ax, funcionponerangoy
    mov cx, menor
    mov dx, mayor
    int interrupcionraton
  end;

  procedure ponecursorgrafico (cursor : pcursor); assembler;
  asm
    mov ax, funcionponecursorgrafico
    les di, cursor
    mov bx, es:word ptr [di]
    mov cx, es:word ptr [di + 2]
    mov dx, di
    add dx, 4
    int interrupcionraton
  end;

  procedure ponecursortextoaplicacion (mascara, imagen : word); assembler;
  asm
    mov ax, funcionponecursortexto
    xor bx, bx
    mov cx, mascara
    mov dx, imagen
    int interrupcionraton
  end;

  procedure ponecursortextoequipo (inicio, fin : word); assembler;
  asm
    mov ax, funcionponecursortexto
    mov bx, 1
    mov cx, inicio
    mov dx, fin
    int interrupcionraton
  end;

  procedure tomamovimiento (var x, y : word); assembler;
  asm
    mov ax, funciontomamovimiento
    int interrupcionraton
    les di, x
    mov es:word ptr [di], cx
    les di, y
    mov es:word ptr [di], dx
  end;

  procedure ponerutina (llamada : word; rutina : pointer); assembler;
  asm
    mov ax, funcionponerutina
    mov cx, llamada
    les dx, rutina
    int interrupcionraton
  end;

  procedure ponelapizoptico; assembler;
  asm
    mov ax, funcionponelapizoptico
    int interrupcionraton
  end;

  procedure quitalapizoptico; assembler;
  asm
    mov ax, funcionquitalapizoptico
    int interrupcionraton
  end;

  procedure ponemovimiento (x, y : word); assembler;
  asm
    mov ax, funcionponemovimiento
    mov cx, x
    mov dx, y
    int interrupcionraton
  end;

  procedure poneactualizacion (x1, y1, x2, y2 : word); assembler;
  asm
    mov ax, funcionponeactualizacion
    mov cx, x1
    mov dx, y1
    mov si, x2
    mov di, y2
    int interrupcionraton
  end;

  procedure ponedoblevelocidad (velocidad : word); assembler;
  asm
    mov ax, funcionponedoblevelocidad
    mov dx, velocidad
    int interrupcionraton
  end;

  procedure cambiarutinas (llamada : word; rutina : pointer;
    var viejallamada : word; viejarutina : pointer); assembler;
  asm
    mov ax, funcioncambiarutinas
    mov cx, llamada
    les dx, rutina
    int interrupcionraton
    les di, viejallamada
    mov es:word ptr [di], cx
    les di, viejarutina
    mov es:word ptr [di], dx
    mov es:word ptr [di + 2], es
  end;

  function tomatamanoestado : word; assembler;
  asm
    mov ax, funciontomatamanoestado
    int interrupcionraton
    mov ax, bx
  end;

  procedure salvaestado (hacia : pointer); assembler;
  asm
    mov ax, funcionsalvaestado
    les dx, hacia
    int interrupcionraton
  end;

  procedure poneestado (desde : pointer); assembler;
  asm
    mov ax, funcionponeestado
    les dx, desde
    int interrupcionraton
  end;

  procedure poneinterrupcionalterna (llamada : word; campo : word);
    assembler;
  asm
    mov ax, funcionponeinterrupcionalterna
    mov cx, llamada
{La base de datos Interrupt Services DOS-BIOS-EMS-Mouse de HelpPC dice que
use dx para indicar la direccin cercana de la rutina (solo su campo),
mientras que la base de datos Interrupts & Ports de Norton Guides SOSPECHA
que debe usar bx:dx para indicar la direccin lejana de la rutina...
Y entonces?!}
    mov dx, campo
    int interrupcionraton
  end;

  function tomainterrupcionalterna (llamada : word) : pointer; assembler;
  asm
    mov ax, funciontomainterrupcionalterna
    mov cx, llamada
    int interrupcionraton
    mov ax, dx
    mov dx, bx
  end;

  procedure ponesensibilidad (x, y, velocidad : word); assembler;
  asm
    mov ax, funcionponesensibilidad
    mov bx, x
    mov cx, y
    mov dx, velocidad
    int interrupcionraton
  end;

  procedure tomasensibilidad (var x, y, velocidad : word); assembler;
  asm
    mov ax, funciontomasensibilidad
    int interrupcionraton
    les di, x
    mov es:word ptr [di], bx
    les di, y
    mov es:word ptr [di], cx
    les di, velocidad
    mov es:word ptr [di], dx
  end;

  procedure ponetiempointerrupcion (tiempo : word); assembler;
  asm
    mov ax, funcionponetiempointerrupcion
    mov bx, tiempo
    int interrupcionraton
  end;

  procedure ponepagina (pagina : word); assembler;
  asm
    mov ax, funcionponepagina
    mov bx, pagina
    int interrupcionraton
  end;

  function tomapagina : word; assembler;
  asm
    mov ax, funciontomapagina
    int interrupcionraton
    mov ax, bx
  end;

  procedure desactiva (var estado : word; var viejainterrupcion : pointer);
    assembler;
  asm
    mov ax, funciondesactiva
    int interrupcionraton
    les di, estado
    mov es:word ptr [di], ax
    les di, viejainterrupcion
    mov es:word ptr [di], bx
    mov es:word ptr [di + 2], es
  end;

  procedure activa; assembler;
  asm
    mov ax, funcionactiva
    int interrupcionraton
  end;

  procedure ajustaaplicacion; assembler;
  asm
    mov ax, funcionajustaaplicacion
    int interrupcionraton
  end;

  procedure poneidioma (idioma : word); assembler;
  asm
    mov ax, funcionponeidioma
    mov bx, idioma
    int interrupcionraton
  end;

  function tomaidioma : word; assembler;
  asm
    mov ax, funciontomaidioma
    int interrupcionraton
    mov ax, bx
  end;

  procedure tomaversiontipo (var mayor, menor, tipo, interrupcion : byte);
    assembler;
  asm
    mov ax, funciontomaversiontipo
    int interrupcionraton
    les di, mayor
    mov es:byte ptr [di], bh
    les di, menor
    mov es:byte ptr [di], bl
    les di, tipo
    mov es:byte ptr [di], ch
    les di, interrupcion
    mov es:byte ptr [di], cl
  end;

  function tomainterrupcion (interrupcion : byte) : pointer; assembler;
  asm
    mov ah, 35h
    mov al, interrupcion
    int 21h
    mov dx, es
    mov ax, bx
  end;

  procedure poneinterrupcion (indice : byte; direccion : pointer); assembler;
  asm
    push ds
    mov ah, 25h
    mov al, indice
    lds dx, direccion
    int 21h
    pop ds
  end;

begin
  error := 0;

  if tomainterrupcion (interrupcionraton) = nil then
  begin
    error := 1;
  end;

  ajusta (estado, botones);

  if estado = 0 then
  begin
    error := 1;
  end;

end.